# coding: utf-8

"""
    Carbon API (Draft)

    An API to interact with Carbon's Manufacturing Cloud including 3D model upload, automated order processing and part history.  Getting started ---------------  - [Generate and download an API key](https://carbon3d.print.carbon3d.com/api_keys)   - Your API key and client secret will be downloaded into a secret.json file.  - [Use generated API key to generate a JWT token](/token_generator) from the api key.   - If your API key is revoked, this token will no longer work.  - Authorize with generated token  - Upload mesh files  - Create orders  - Monitor order status   # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: api-list@carbon3d.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from carbon3d.configuration import Configuration


class PrinterPrints(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'last': 'ModelPrint',
        'current': 'ModelPrint',
        'next': 'ModelPrint',
        'queue_length': 'int'
    }

    attribute_map = {
        'last': 'last',
        'current': 'current',
        'next': 'next',
        'queue_length': 'queue_length'
    }

    def __init__(self, last=None, current=None, next=None, queue_length=None, local_vars_configuration=None):  # noqa: E501
        """PrinterPrints - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._last = None
        self._current = None
        self._next = None
        self._queue_length = None
        self.discriminator = None

        if last is not None:
            self.last = last
        if current is not None:
            self.current = current
        if next is not None:
            self.next = next
        self.queue_length = queue_length

    @property
    def last(self):
        """Gets the last of this PrinterPrints.  # noqa: E501


        :return: The last of this PrinterPrints.  # noqa: E501
        :rtype: ModelPrint
        """
        return self._last

    @last.setter
    def last(self, last):
        """Sets the last of this PrinterPrints.


        :param last: The last of this PrinterPrints.  # noqa: E501
        :type: ModelPrint
        """

        self._last = last

    @property
    def current(self):
        """Gets the current of this PrinterPrints.  # noqa: E501


        :return: The current of this PrinterPrints.  # noqa: E501
        :rtype: ModelPrint
        """
        return self._current

    @current.setter
    def current(self, current):
        """Sets the current of this PrinterPrints.


        :param current: The current of this PrinterPrints.  # noqa: E501
        :type: ModelPrint
        """

        self._current = current

    @property
    def next(self):
        """Gets the next of this PrinterPrints.  # noqa: E501


        :return: The next of this PrinterPrints.  # noqa: E501
        :rtype: ModelPrint
        """
        return self._next

    @next.setter
    def next(self, next):
        """Sets the next of this PrinterPrints.


        :param next: The next of this PrinterPrints.  # noqa: E501
        :type: ModelPrint
        """

        self._next = next

    @property
    def queue_length(self):
        """Gets the queue_length of this PrinterPrints.  # noqa: E501


        :return: The queue_length of this PrinterPrints.  # noqa: E501
        :rtype: int
        """
        return self._queue_length

    @queue_length.setter
    def queue_length(self, queue_length):
        """Sets the queue_length of this PrinterPrints.


        :param queue_length: The queue_length of this PrinterPrints.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and queue_length is None:  # noqa: E501
            raise ValueError("Invalid value for `queue_length`, must not be `None`")  # noqa: E501

        self._queue_length = queue_length

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PrinterPrints):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PrinterPrints):
            return True

        return self.to_dict() != other.to_dict()
